<?xml version="1.0" encoding="UTF-8"?>
<xsl:stylesheet version="2.0"
	xmlns:xsl="http://www.w3.org/1999/XSL/Transform" xmlns:tdm="http://www.quest.com/toad-data-modeler"
	xmlns:w="http://schemas.microsoft.com/office/word/2003/wordml"
	xmlns:wx="http://schemas.microsoft.com/office/word/2003/auxHint"
	xmlns:aml="http://schemas.microsoft.com/aml/2001/core" xmlns:msxsl="urn:schemas-microsoft-com:xslt">
	<tdm:description>Sample template that shows how to generate MS Word documents via XSLT. The output contains model info, ToDo list, some basic information about entities and relationships. This template should be modified and improved.</tdm:description>
	<tdm:caption>Report MS Word (XML)</tdm:caption>
	<tdm:default-filename>modelreport</tdm:default-filename>
	<tdm:default-suffix>xml</tdm:default-suffix>
	<tdm:db-platforms>
		<tdm:db-platform>all</tdm:db-platform>
	</tdm:db-platforms>


	<xsl:output method="xml" indent="yes" omit-xml-declaration="no"
		encoding="UTF-8" />
	<xsl:decimal-format name="format1"
		grouping-separator=" " decimal-separator="," />
	<xsl:template match="/">
		<xsl:text disable-output-escaping="yes">&lt;?mso-application progid="Word.Document"?&gt;</xsl:text>
		<w:wordDocument xmlns:w="http://schemas.microsoft.com/office/word/2003/wordml"
			xmlns:wx="http://schemas.microsoft.com/office/word/2003/auxHint"
			xmlns:aml="http://schemas.microsoft.com/aml/2001/core">

			<!-- *********************************************************************************** -->
			<!-- Styles -->
			<!-- *********************************************************************************** -->
			<w:styles>
				<w:style w:type="character" w:styleId="Hyperlink">
					<w:name w:val="Hyperlink" />
					<w:basedOn w:val="DefaultParagraphFont" />
					<w:rsid w:val="365462" />
					<w:rPr>
						<w:color w:val="0000FF" />
						<w:u w:val="single" />
					</w:rPr>
				</w:style>

				<w:style w:type="paragraph" w:styleId="Caption1">
					<w:name w:val="Caption 1" />
					<w:next w:val="Normln" />
					<w:rsid w:val="005A69A8" />
					<w:pPr>
						<w:keepNext />
						<w:keepLines />
						<w:spacing w:before="300" w:after="200" />
						<w:outlineLvl w:val="0" />
					</w:pPr>
					<w:rPr>
						<w:rFonts w:ascii="Cambria" w:h-ansi="Cambria" />
						<wx:font wx:val="Cambria" />
						<w:b />
						<w:b-cs />
						<w:color w:val="C0504D" />
						<w:sz w:val="28" />
						<w:sz-cs w:val="28" />
						<w:lang w:val="EN-US" w:fareast="EN-US" w:bidi="AR-SA" />
					</w:rPr>
				</w:style>
				<w:style w:type="paragraph" w:styleId="Caption2">
					<w:name w:val="Caption 2" />
					<w:rsid w:val="00970333" />
					<w:pPr>
						<w:keepNext />
						<w:keepLines />
						<w:pBdr>
							<w:top w:val="single" w:sz="12" wx:bdrwidth="30" w:space="1"
								w:color="4F81BD" />
						</w:pBdr>
						<w:shd w:val="clear" w:color="auto" w:fill="DBE5F1" />
						<w:spacing w:before="180" w:after="120" />
						<w:outlineLvl w:val="1" />
					</w:pPr>
					<w:rPr>
						<w:rFonts w:ascii="Cambria" w:h-ansi="Cambria" />
						<wx:font wx:val="Cambria" />
						<w:b />
						<w:b-cs />
						<w:color w:val="1F497D" />
						<w:sz w:val="24" />
						<w:sz-cs w:val="22" />
						<w:lang w:val="EN-US" w:fareast="EN-US" w:bidi="AR-SA" />
					</w:rPr>
				</w:style>
				<w:style w:type="paragraph" w:styleId="Caption3">
					<w:name w:val="Caption 3" />
					<w:next w:val="Normln" />
					<w:rsid w:val="00982084" />
					<w:pPr>
						<w:spacing w:before="120" w:after="60" />
						<w:outlineLvl w:val="2" />
					</w:pPr>
					<w:rPr>
						<w:rFonts w:ascii="Cambria" w:h-ansi="Cambria" />
						<wx:font wx:val="Cambria" />
						<w:b />
						<w:b-cs />
						<w:color w:val="365F91" />
						<w:sz-cs w:val="22" />
						<w:lang w:val="EN-US" w:fareast="EN-US" w:bidi="AR-SA" />
					</w:rPr>
				</w:style>

				<w:style w:type="table" w:styleId="tblStyle1">
					<w:name w:val="tblStyle1" />
					<w:basedOn w:val="Normlntabulka" />
					<w:rsid w:val="00735735" />
					<w:rPr>
						<w:rFonts w:ascii="Cambria" w:h-ansi="Cambria" />
						<wx:font wx:val="Cambria" />
					</w:rPr>
					<w:tblPr>
						<w:tblInd w:w="0" w:type="dxa" />
						<w:tblBorders>
							<w:top w:val="single" w:sz="4" wx:bdrwidth="10" w:space="0"
								w:color="1F497D" />
							<w:left w:val="single" w:sz="4" wx:bdrwidth="10" w:space="0"
								w:color="1F497D" />
							<w:bottom w:val="single" w:sz="4" wx:bdrwidth="10"
								w:space="0" w:color="1F497D" />
							<w:right w:val="single" w:sz="4" wx:bdrwidth="10"
								w:space="0" w:color="1F497D" />
							<w:insideH w:val="single" w:sz="4" wx:bdrwidth="10"
								w:space="0" w:color="DBE5F1" />
							<w:insideV w:val="single" w:sz="4" wx:bdrwidth="10"
								w:space="0" w:color="DBE5F1" />
						</w:tblBorders>
						<w:tblCellMar>
							<w:top w:w="0" w:type="dxa" />
							<w:left w:w="108" w:type="dxa" />
							<w:bottom w:w="0" w:type="dxa" />
							<w:right w:w="108" w:type="dxa" />
						</w:tblCellMar>
					</w:tblPr>
					<w:tblStylePr w:type="firstRow">
						<w:pPr>
							<w:jc w:val="center" />
						</w:pPr>
						<w:rPr>
							<w:rFonts w:ascii="Cambria" w:h-ansi="Cambria" />
							<wx:font wx:val="Cambria" />
							<w:b />
							<w:color w:val="auto" />
							<w:sz w:val="20" />
						</w:rPr>
						<w:tblPr />
						<w:tcPr>
							<w:tcBorders>
								<w:top w:val="single" w:sz="4" wx:bdrwidth="10" w:space="0"
									w:color="1F497D" />
								<w:left w:val="single" w:sz="4" wx:bdrwidth="10" w:space="0"
									w:color="1F497D" />
								<w:bottom w:val="single" w:sz="4" wx:bdrwidth="10"
									w:space="0" w:color="1F497D" />
								<w:right w:val="single" w:sz="4" wx:bdrwidth="10"
									w:space="0" w:color="1F497D" />
								<w:insideH w:val="single" w:sz="4" wx:bdrwidth="10"
									w:space="0" w:color="1F497D" />
								<w:insideV w:val="single" w:sz="4" wx:bdrwidth="10"
									w:space="0" w:color="1F497D" />
							</w:tcBorders>
							<w:shd w:val="clear" w:color="auto" w:fill="DBE5F1" />
							<w:vAlign w:val="center" />
						</w:tcPr>
					</w:tblStylePr>
				</w:style>
				<w:style w:type="table" w:styleId="tblStyle2">
					<w:name w:val="tblStyle2" />
					<w:basedOn w:val="tblStyle1" />
					<w:rsid w:val="00CC6A71" />
					<w:rPr>
						<wx:font wx:val="Cambria" />
					</w:rPr>
					<w:tblPr>
						<w:tblInd w:w="0" w:type="dxa" />
						<w:tblBorders>
							<w:top w:val="single" w:sz="4" wx:bdrwidth="10" w:space="0"
								w:color="1F497D" />
							<w:left w:val="single" w:sz="4" wx:bdrwidth="10" w:space="0"
								w:color="1F497D" />
							<w:bottom w:val="single" w:sz="4" wx:bdrwidth="10"
								w:space="0" w:color="1F497D" />
							<w:right w:val="single" w:sz="4" wx:bdrwidth="10"
								w:space="0" w:color="1F497D" />
							<w:insideH w:val="single" w:sz="4" wx:bdrwidth="10"
								w:space="0" w:color="DBE5F1" />
							<w:insideV w:val="single" w:sz="4" wx:bdrwidth="10"
								w:space="0" w:color="DBE5F1" />
						</w:tblBorders>
						<w:tblCellMar>
							<w:top w:w="0" w:type="dxa" />
							<w:left w:w="108" w:type="dxa" />
							<w:bottom w:w="0" w:type="dxa" />
							<w:right w:w="108" w:type="dxa" />
						</w:tblCellMar>
					</w:tblPr>
					<w:tblStylePr w:type="firstRow">
						<w:tblPr />
						<w:tcPr>
							<w:tcBorders>
								<w:top w:val="single" w:sz="4" wx:bdrwidth="10" w:space="0"
									w:color="1F497D" />
								<w:left w:val="single" w:sz="4" wx:bdrwidth="10" w:space="0"
									w:color="1F497D" />
								<w:bottom w:val="single" w:sz="4" wx:bdrwidth="10"
									w:space="0" w:color="1F497D" />
								<w:right w:val="single" w:sz="4" wx:bdrwidth="10"
									w:space="0" w:color="1F497D" />
								<w:insideH w:val="single" w:sz="4" wx:bdrwidth="10"
									w:space="0" w:color="1F497D" />
								<w:insideV w:val="single" w:sz="4" wx:bdrwidth="10"
									w:space="0" w:color="1F497D" />
							</w:tcBorders>
							<w:shd w:val="clear" w:color="auto" w:fill="DBE5F1" />
							<w:vAlign w:val="center" />
						</w:tcPr>
					</w:tblStylePr>
					<w:tblStylePr w:type="firstCol">
						<w:tblPr />
						<w:tcPr>
							<w:tcBorders>
								<w:top w:val="single" w:sz="4" wx:bdrwidth="10" w:space="0"
									w:color="auto" />
								<w:left w:val="single" w:sz="4" wx:bdrwidth="10" w:space="0"
									w:color="auto" />
								<w:bottom w:val="single" w:sz="4" wx:bdrwidth="10"
									w:space="0" w:color="auto" />
								<w:right w:val="single" w:sz="4" wx:bdrwidth="10"
									w:space="0" w:color="auto" />
								<w:insideH w:val="single" w:sz="4" wx:bdrwidth="10"
									w:space="0" w:color="auto" />
								<w:insideV w:val="single" w:sz="4" wx:bdrwidth="10"
									w:space="0" w:color="auto" />
							</w:tcBorders>
							<w:shd w:val="clear" w:color="auto" w:fill="DBE5F1" />
						</w:tcPr>
					</w:tblStylePr>
				</w:style>

				<w:style w:type="table" w:styleId="tblStyle3">
					<w:name w:val="tblStyle3" />
					<w:basedOn w:val="tblStyle1" />
					<w:rsid w:val="00CC6A71" />
					<w:rPr>
						<wx:font wx:val="Cambria" />
					</w:rPr>
					<w:tblPr>
						<w:tblStyleColBandSize w:val="1" />
						<w:tblInd w:w="0" w:type="dxa" />
						<w:tblBorders>
							<w:top w:val="single" w:sz="4" wx:bdrwidth="10" w:space="0"
								w:color="1F497D" />
							<w:left w:val="single" w:sz="4" wx:bdrwidth="10" w:space="0"
								w:color="1F497D" />
							<w:bottom w:val="single" w:sz="4" wx:bdrwidth="10"
								w:space="0" w:color="1F497D" />
							<w:right w:val="single" w:sz="4" wx:bdrwidth="10"
								w:space="0" w:color="1F497D" />
							<w:insideH w:val="single" w:sz="4" wx:bdrwidth="10"
								w:space="0" w:color="DBE5F1" />
							<w:insideV w:val="single" w:sz="4" wx:bdrwidth="10"
								w:space="0" w:color="DBE5F1" />
						</w:tblBorders>
						<w:tblCellMar>
							<w:top w:w="0" w:type="dxa" />
							<w:left w:w="108" w:type="dxa" />
							<w:bottom w:w="0" w:type="dxa" />
							<w:right w:w="108" w:type="dxa" />
						</w:tblCellMar>
					</w:tblPr>
					<w:tblStylePr w:type="firstRow">
						<w:rPr>
							<w:rFonts w:ascii="Cambria" w:h-ansi="Cambria" />
							<wx:font wx:val="Cambria" />
							<w:b w:val="off" />
							<w:color w:val="auto" />
							<w:sz w:val="20" />
						</w:rPr>
					</w:tblStylePr>
					<w:tblStylePr w:type="band1Vert">
						<w:tblPr />
						<w:tcPr>
							<w:tcBorders>
								<w:top w:val="single" w:sz="4" wx:bdrwidth="10" w:space="0"
									w:color="auto" />
								<w:left w:val="single" w:sz="4" wx:bdrwidth="10" w:space="0"
									w:color="auto" />
								<w:bottom w:val="single" w:sz="4" wx:bdrwidth="10"
									w:space="0" w:color="auto" />
								<w:right w:val="single" w:sz="4" wx:bdrwidth="10"
									w:space="0" w:color="auto" />
								<w:insideH w:val="single" w:sz="4" wx:bdrwidth="10"
									w:space="0" w:color="auto" />
								<w:insideV w:val="single" w:sz="4" wx:bdrwidth="10"
									w:space="0" w:color="auto" />
							</w:tcBorders>
							<w:shd w:val="clear" w:color="auto" w:fill="DBE5F1" />
						</w:tcPr>
					</w:tblStylePr>
				</w:style>

				<w:style w:type="table" w:styleId="tblStyle4">
					<w:name w:val="tblStyle4" />
					<w:basedOn w:val="tblStyle3" />
					<w:rsid w:val="00CC6A71" />
					<w:rPr>
						<wx:font wx:val="Cambria" />
					</w:rPr>
					<w:tblPr>
						<w:tblStyleColBandSize w:val="1" />
						<w:tblInd w:w="0" w:type="dxa" />
						<w:tblBorders>
							<w:top w:val="single" w:sz="4" wx:bdrwidth="10" w:space="0"
								w:color="1F497D" />
							<w:left w:val="single" w:sz="4" wx:bdrwidth="10" w:space="0"
								w:color="1F497D" />
							<w:bottom w:val="single" w:sz="4" wx:bdrwidth="10"
								w:space="0" w:color="1F497D" />
							<w:right w:val="single" w:sz="4" wx:bdrwidth="10"
								w:space="0" w:color="1F497D" />
							<w:insideH w:val="single" w:sz="4" wx:bdrwidth="10"
								w:space="0" w:color="DBE5F1" />
							<w:insideV w:val="single" w:sz="4" wx:bdrwidth="10"
								w:space="0" w:color="DBE5F1" />
						</w:tblBorders>
						<w:tblCellMar>
							<w:top w:w="0" w:type="dxa" />
							<w:left w:w="108" w:type="dxa" />
							<w:bottom w:w="0" w:type="dxa" />
							<w:right w:w="108" w:type="dxa" />
						</w:tblCellMar>
					</w:tblPr>

					<w:tblStylePr w:type="band1Vert">
						<w:tblPr />
						<w:tcPr>
							<w:tcBorders>
								<w:top w:val="single" w:sz="4" wx:bdrwidth="10" w:space="0"
									w:color="auto" />
								<w:left w:val="single" w:sz="4" wx:bdrwidth="10" w:space="0"
									w:color="auto" />
								<w:bottom w:val="single" w:sz="4" wx:bdrwidth="10"
									w:space="0" w:color="auto" />
								<w:right w:val="single" w:sz="4" wx:bdrwidth="10"
									w:space="0" w:color="auto" />
								<w:insideH w:val="single" w:sz="4" wx:bdrwidth="10"
									w:space="0" w:color="auto" />
								<w:insideV w:val="single" w:sz="4" wx:bdrwidth="10"
									w:space="0" w:color="auto" />
							</w:tcBorders>
							<w:shd w:val="clear" w:color="auto" w:fill="DBE5F1" />
						</w:tcPr>
					</w:tblStylePr>
				</w:style>

			</w:styles>

			<!-- *********************************************************************************** -->
			<!-- Document properties -->
			<!-- *********************************************************************************** -->
			<w:docPr>
				<w:view w:val="print" />
				<w:zoom w:percent="100" />
			</w:docPr>

			<!-- *********************************************************************************** -->
			<!-- Body -->
			<!-- *********************************************************************************** -->
			<w:body>
				<xsl:call-template name="ModelInfo" />
				<xsl:call-template name="ToDo" />
				<xsl:call-template name="EntityOverview" />
				<xsl:call-template name="EntityDetails" />
				<xsl:call-template name="RelationshipOverview" />
				<xsl:call-template name="RelationshipDetails" />
			</w:body>
		</w:wordDocument>
	</xsl:template>

	<!-- *********************************************************************************** -->
	<!-- Global templates -->
	<!-- *********************************************************************************** -->
	<xsl:template name="DomainDetails">
		<xsl:param name="domainid" />
		<xsl:for-each select="/Model/Domains/Domain">
			<xsl:if test="Id=$domainid">
				<xsl:call-template name="SubstringText">
					<xsl:with-param name="text" select="DataType/Name" />
					<xsl:with-param name="char" select="'('" />
				</xsl:call-template>
				<xsl:if test="string-length(DataType/Param1)>0">
					<xsl:text> (</xsl:text>
					<xsl:value-of select="DataType/Param1" />
					<xsl:if test="string-length(DataType/Param2)>0">
						<xsl:text>, </xsl:text>
						<xsl:value-of select="DataType/Param2" />
					</xsl:if>
					<xsl:text>)</xsl:text>
				</xsl:if>
			</xsl:if>
		</xsl:for-each>
	</xsl:template>

	<xsl:template name="BooleanToText">
		<xsl:param name="PassedValue" />
		<xsl:choose>
			<xsl:when test="$PassedValue = 1">
				<xsl:text>Yes</xsl:text>
			</xsl:when>
			<xsl:otherwise>
				<xsl:text>-</xsl:text>
			</xsl:otherwise>
		</xsl:choose>
	</xsl:template>

	<xsl:template name="SubstringText">
		<xsl:param name="text" />
		<xsl:param name="char" />
		<xsl:choose>
			<xsl:when test="contains($text, $char)">
				<xsl:value-of select="substring-before($text,$char)" />
			</xsl:when>
			<xsl:otherwise>
				<xsl:value-of select="$text" />
			</xsl:otherwise>
		</xsl:choose>
	</xsl:template>

	<!-- *********************************************************************************** -->
	<!-- Entity Overview -->
	<!-- *********************************************************************************** -->
	<xsl:template name="EntityOverview">
		<w:p>
			<w:pPr>
				<w:pStyle w:val="Caption1" />
			</w:pPr>
			<w:r>

				<w:t>Entities</w:t>
			</w:r>
		</w:p>

		<w:tbl>

			<w:tblPr>
				<w:tblStyle w:val="tblStyle1" />
				<w:tblW w:w="5000" w:type="pct" />
				<w:tblLook w:val="000001E0" />
			</w:tblPr>

			<w:tr>
				<w:tc>
					<w:p>
						<w:r>
							<w:t>Name</w:t>
						</w:r>
					</w:p>
				</w:tc>
				<w:tc>
					<w:p>
						<w:r>
							<w:t>Caption</w:t>
						</w:r>
					</w:p>
				</w:tc>
				<w:tc>
					<w:p>
						<w:r>
							<w:t>Primary Key</w:t>
						</w:r>
					</w:p>
				</w:tc>
				<w:tc>
					<w:p>
						<w:r>
							<w:t>Attributes</w:t>
						</w:r>
					</w:p>
				</w:tc>
			</w:tr>
			<xsl:for-each select="Model/Entities/Entity">
				<w:tr>
					<w:tc>
						<w:p>
							<xsl:text disable-output-escaping="yes">&lt;w:hlink w:bookmark="</xsl:text>
							<xsl:text>bkm_</xsl:text>
							<xsl:value-of select="translate(translate(Id,'}',''),'{','')" />
							<xsl:text disable-output-escaping="yes">" &gt;</xsl:text>
							<w:r>


								<w:rPr>
									<w:rStyle w:val="Hyperlink" />
								</w:rPr>
								<w:t>
									<xsl:value-of select="FullName" />
								</w:t>
							</w:r>
							<xsl:text disable-output-escaping="yes">&lt;/w:hlink &gt;</xsl:text>
						</w:p>
					</w:tc>
					<w:tc>
						<w:p>
							<w:r>
								<w:t>
									<xsl:value-of select="Caption" />
								</w:t>
							</w:r>
						</w:p>
					</w:tc>
					<w:tc>
						<w:p>
							<w:r>
								<w:t>
									<xsl:value-of select="PrimaryKeys/FullName" />
								</w:t>
							</w:r>
						</w:p>
					</w:tc>
					<w:tc>
						<w:p>
							<w:r>
								<w:t>
									<xsl:value-of select="count(Attributes/Attribute)" />
								</w:t>
							</w:r>
						</w:p>
					</w:tc>
				</w:tr>

			</xsl:for-each>
		</w:tbl>
	</xsl:template>

	<!-- *********************************************************************************** -->
	<!-- Entity Details -->
	<!-- *********************************************************************************** -->
	<xsl:template name="EntityDetails">
		<w:p>
			<w:pPr>
				<w:pStyle w:val="Caption1" />
			</w:pPr>
			<w:r>

				<w:t>Entity Details</w:t>
			</w:r>
		</w:p>


		<xsl:for-each select="Model/Entities/Entity">

			<xsl:text disable-output-escaping="yes">&lt;aml:annotation aml:id="</xsl:text>
			<xsl:text>bkm_</xsl:text>
			<xsl:value-of select="translate(translate(Id,'}',''),'{','')" />
			<xsl:text disable-output-escaping="yes">" w:type="Word.Bookmark.Start" w:name="</xsl:text>
			<xsl:text>bkm_</xsl:text>
			<xsl:value-of select="translate(translate(Id,'}',''),'{','')" />
			<xsl:text disable-output-escaping="yes">" /&gt;</xsl:text>
			<xsl:text disable-output-escaping="yes">&lt;aml:annotation aml:id="</xsl:text>
			<xsl:text>bkm_</xsl:text>
			<xsl:value-of select="translate(translate(Id,'}',''),'{','')" />
			<xsl:text disable-output-escaping="yes">" w:type="Word.Bookmark.End" /&gt;</xsl:text>

			<w:p>
				<w:pPr>
					<w:pStyle w:val="Caption2" />
				</w:pPr>
				<w:r>
					<w:t>
						<xsl:value-of select="FullName" />
					</w:t>
				</w:r>
			</w:p>


			<w:p>
				<w:r>
					<w:t>Caption: </w:t>
				</w:r>
				<w:rPr>
					<w:b w:val="on" />
				</w:rPr>
				<w:r>
					<w:t>
						<xsl:value-of select="Caption" />
					</w:t>
				</w:r>
			</w:p>
			<xsl:if test="(Comments)!=''">
				<w:p>
					<w:r>
						<w:t>Description: </w:t>
					</w:r>
					<w:rPr>
						<w:b w:val="on" />
					</w:rPr>
					<w:r>

						<w:t>
							<xsl:value-of select="Comments" />
						</w:t>
					</w:r>
				</w:p>
			</xsl:if>


			<w:p>
				<w:pPr>
					<w:pStyle w:val="Caption3" />
				</w:pPr>
				<w:r>
					<w:t>Attributes</w:t>
				</w:r>
			</w:p>

			<w:tbl>

				<w:tblPr>
					<w:tblStyle w:val="tblStyle1" />
					<w:tblW w:w="5000" w:type="pct" />
					<w:tblLook w:val="000001E0" />
				</w:tblPr>

				<w:tr>
					<w:tc>
						<w:p>
							<w:r>
								<w:t>Key</w:t>
							</w:r>
						</w:p>
					</w:tc>
					<w:tc>
						<w:p>
							<w:r>
								<w:t>Caption</w:t>
							</w:r>
						</w:p>
					</w:tc>
					<w:tc>
						<w:p>
							<w:r>
								<w:t>Name</w:t>
							</w:r>
						</w:p>
					</w:tc>
					<w:tc>
						<w:p>
							<w:r>
								<w:t>Data Type</w:t>
							</w:r>
						</w:p>
					</w:tc>
					<w:tc>
						<w:p>
							<w:r>
								<w:t>Not Null</w:t>
							</w:r>
						</w:p>
					</w:tc>
					<w:tc>
						<w:p>
							<w:r>
								<w:t>Unique</w:t>
							</w:r>
						</w:p>
					</w:tc>
					<w:tc>
						<w:p>
							<w:r>
								<w:t>Check</w:t>
							</w:r>
						</w:p>
					</w:tc>
					<w:tc>
						<w:p>
							<w:r>
								<w:t>Default</w:t>
							</w:r>
						</w:p>
					</w:tc>
					<w:tc>
						<w:p>
							<w:r>
								<w:t>Comments</w:t>
							</w:r>
						</w:p>
					</w:tc>
				</w:tr>

				<xsl:for-each select="Attributes/Attribute">
					<w:tr>
						<w:tc>
							<w:p>
								<w:r>
									<w:t>
										<xsl:if
											test="string-length(KeyItems/ReferencedObject/Name)>0 or string-length(ForeignOtherKeys/ReferencedObject/Name)>0">
											<xsl:text>Yes</xsl:text>
										</xsl:if>
									</w:t>
								</w:r>
							</w:p>
						</w:tc>
						<w:tc>
							<w:p>
								<w:r>
									<w:t>
										<xsl:value-of select="Caption" />
									</w:t>
								</w:r>
							</w:p>
						</w:tc>
						<w:tc>
							<w:p>
								<w:r>
									<w:t>
										<xsl:value-of select="Name" />
									</w:t>
								</w:r>
							</w:p>
						</w:tc>
						<w:tc>
							<w:p>
								<w:r>
									<w:t>
										<xsl:choose>
											<xsl:when test="string-length(DataType/Name)>0">
												<xsl:call-template name="SubstringText">
													<xsl:with-param name="text" select="DataType/Name" />
													<xsl:with-param name="char" select="'('" />
												</xsl:call-template>
												<xsl:if test="string-length(DataType/Param1)>0">
													<xsl:text> (</xsl:text>
													<xsl:value-of select="DataType/Param1" />
													<xsl:if test="string-length(DataType/Param2)>0">
														<xsl:text>, </xsl:text>
														<xsl:value-of select="DataType/Param2" />
													</xsl:if>
													<xsl:text>)</xsl:text>
												</xsl:if>

											</xsl:when>
											<xsl:when test="string-length(Domain/Name)>0">
												<xsl:call-template name="DomainDetails">
													<xsl:with-param name="domainid" select="Domain/Id" />
												</xsl:call-template>
											</xsl:when>
											<xsl:when test="string-length(UserDataType/Name)>0">
												<xsl:value-of select="UserDataType/Name" />
											</xsl:when>
											<xsl:otherwise>
												<xsl:text disable-output-escaping="yes">?</xsl:text>
											</xsl:otherwise>
										</xsl:choose>
									</w:t>
								</w:r>
							</w:p>
						</w:tc>
						<w:tc>
							<w:p>
								<w:r>
									<w:t>
										<xsl:call-template name="BooleanToText">
											<xsl:with-param name="PassedValue" select="NotNull" />
										</xsl:call-template>
									</w:t>
								</w:r>
							</w:p>
						</w:tc>
						<w:tc>
							<w:p>
								<w:r>
									<w:t>
										<xsl:call-template name="BooleanToText">
											<xsl:with-param name="PassedValue" select="Unique" />
										</xsl:call-template>

									</w:t>
								</w:r>
							</w:p>
						</w:tc>
						<w:tc>
							<w:p>
								<w:r>
									<w:t>
										<xsl:value-of select="CheckContraint" />
									</w:t>
								</w:r>
							</w:p>
						</w:tc>
						<w:tc>
							<w:p>
								<w:r>
									<w:t>
										<xsl:value-of select="DefautlValue" />
									</w:t>
								</w:r>
							</w:p>
						</w:tc>
						<w:tc>
							<w:p>
								<w:r>
									<w:t>
										<xsl:value-of select="Comments" />
									</w:t>
								</w:r>
							</w:p>
						</w:tc>
					</w:tr>


				</xsl:for-each>
			</w:tbl>
		</xsl:for-each>
	</xsl:template>

	<!-- *********************************************************************************** -->
	<!-- Relationship Overview -->
	<!-- *********************************************************************************** -->
	<xsl:template name="RelationshipOverview">
		<w:p>
			<w:pPr>
				<w:pStyle w:val="Caption1" />
			</w:pPr>
			<w:r>
				<w:t>Relationships</w:t>
			</w:r>
		</w:p>
		<w:tbl>

			<w:tblPr>
				<w:tblStyle w:val="tblStyle1" />
				<w:tblW w:w="5000" w:type="pct" />
				<w:tblLook w:val="000001E0" />
			</w:tblPr>

			<w:tr>
				<w:tc>
					<w:p>
						<w:r>
							<w:t>Name</w:t>
						</w:r>
					</w:p>
				</w:tc>
				<w:tc>
					<w:p>
						<w:r>
							<w:t>Caption</w:t>
						</w:r>
					</w:p>
				</w:tc>
				<w:tc>
					<w:p>
						<w:r>
							<w:t>Identif.</w:t>
						</w:r>
					</w:p>
				</w:tc>
				<w:tc>
					<w:p>
						<w:r>
							<w:t>Parent</w:t>
						</w:r>
					</w:p>
				</w:tc>
				<w:tc>
					<w:p>
						<w:r>
							<w:t>Child</w:t>
						</w:r>
					</w:p>
				</w:tc>
			</w:tr>
			<xsl:for-each select="Model/Relationships/Relation">
				<w:tr>
					<w:tc>
						<w:p>
							<w:r>
								<w:t>
									<xsl:value-of select="FullName" />
								</w:t>
							</w:r>
						</w:p>
					</w:tc>
					<w:tc>
						<w:p>
							<w:r>
								<w:t>
									<xsl:value-of select="Caption" />
								</w:t>
							</w:r>
						</w:p>
					</w:tc>
					<w:tc>
						<w:p>
							<w:r>
								<w:t>
									<xsl:call-template name="BooleanToText">
										<xsl:with-param name="PassedValue" select="Identifying" />
									</xsl:call-template>
								</w:t>
							</w:r>
						</w:p>
					</w:tc>
					<w:tc>
						<w:p>
							<xsl:text disable-output-escaping="yes">&lt;w:hlink w:bookmark="</xsl:text>
							<xsl:text>bkm_</xsl:text>
							<xsl:value-of select="translate(translate(O1/Id,'}',''),'{','')" />
							<xsl:text disable-output-escaping="yes">" &gt;</xsl:text>


							<w:r>

								<w:rPr>
									<w:rStyle w:val="Hyperlink" />
								</w:rPr>

								<w:t>
									<xsl:value-of select="O1/FullName" />
									<w:br w:type="text-wrapping" />
								</w:t>
							</w:r>
							<xsl:text disable-output-escaping="yes">&lt;/w:hlink &gt;</xsl:text>
							<w:r>
								<w:t>

									<xsl:text>(</xsl:text>
									<xsl:choose>
										<xsl:when test="count(ForeignKeys/ForeignKey) = 1">
											<xsl:value-of select="ForeignKeys/ForeignKey/ParentAttribute/Name" />


										</xsl:when>

										<xsl:otherwise>
											<xsl:for-each select="ForeignKeys/ForeignKey">
												<xsl:value-of select="ParentAttribute/Name" />
												<xsl:if test="position() != last()">
													<xsl:value-of select="', '" />
												</xsl:if>
											</xsl:for-each>


										</xsl:otherwise>
									</xsl:choose>
									<xsl:text>)</xsl:text>

								</w:t>
							</w:r>

						</w:p>
					</w:tc>
					<w:tc>
						<w:p>
							<xsl:text disable-output-escaping="yes">&lt;w:hlink w:bookmark="</xsl:text>
							<xsl:text>bkm_</xsl:text>
							<xsl:value-of select="translate(translate(O2/Id,'}',''),'{','')" />
							<xsl:text disable-output-escaping="yes">" &gt;</xsl:text>

							<w:r>
								<w:rPr>
									<w:rStyle w:val="Hyperlink" />
								</w:rPr>
								<w:t>
									<xsl:value-of select="O2/FullName" />
									<w:br w:type="text-wrapping" />
								</w:t>
							</w:r>
							<xsl:text disable-output-escaping="yes">&lt;/w:hlink &gt;</xsl:text>
							<w:r>
								<w:t>
									<xsl:text>(</xsl:text>
									<xsl:choose>
										<xsl:when test="count(ForeignKeys/ForeignKey) = 1">

											<xsl:value-of select="ForeignKeys/ForeignKey/ChildAttribute/Name" />
										</xsl:when>
										<xsl:otherwise>
											<xsl:for-each select="ForeignKeys/ForeignKey">
												<xsl:value-of select="ChildAttribute/Name" />
												<xsl:if test="position() != last()">
													<xsl:value-of select="', '" />
												</xsl:if>
											</xsl:for-each>
										</xsl:otherwise>
									</xsl:choose>
									<xsl:text>)</xsl:text>

								</w:t>
							</w:r>
						</w:p>
					</w:tc>
				</w:tr>

			</xsl:for-each>
		</w:tbl>
	</xsl:template>

	<!-- *********************************************************************************** -->
	<!-- Relationship Details -->
	<!-- *********************************************************************************** -->
	<xsl:template name="RelationshipDetails">
		<w:p>
			<w:pPr>
				<w:pStyle w:val="Caption1" />
			</w:pPr>
			<w:r>
				<w:t>Relationship Details</w:t>
			</w:r>
		</w:p>
		<xsl:for-each select="Model/Relationships/Relation">
			<xsl:text disable-output-escaping="yes">&lt;aml:annotation aml:id="</xsl:text>
			<xsl:text>bkm_</xsl:text>
			<xsl:value-of select="translate(translate(Id,'}',''),'{','')" />
			<xsl:text disable-output-escaping="yes">" w:type="Word.Bookmark.Start" w:name="</xsl:text>
			<xsl:text>bkm_</xsl:text>
			<xsl:value-of select="translate(translate(Id,'}',''),'{','')" />
			<xsl:text disable-output-escaping="yes">" /&gt;</xsl:text>
			<xsl:text disable-output-escaping="yes">&lt;aml:annotation aml:id="</xsl:text>
			<xsl:text>bkm_</xsl:text>
			<xsl:value-of select="translate(translate(Id,'}',''),'{','')" />
			<xsl:text disable-output-escaping="yes">" w:type="Word.Bookmark.End" /&gt;</xsl:text>
			<w:p>
				<w:pPr>
					<w:pStyle w:val="Caption2" />
				</w:pPr>
				<w:r>
					<w:t>
						<xsl:value-of select="FullName" />
					</w:t>
				</w:r>
			</w:p>
			<w:p>
				<w:r>
					<w:t>Caption: </w:t>
				</w:r>
				<w:rPr>
					<w:b w:val="on" />
				</w:rPr>
				<w:r>
					<w:t>
						<xsl:value-of select="Caption" />
					</w:t>
				</w:r>
			</w:p>
			<xsl:if test="(Comments)!=''">
				<w:p>
					<w:r>
						<w:t>Description: </w:t>
					</w:r>
					<w:rPr>
						<w:b w:val="on" />
					</w:rPr>
					<w:r>
						<w:t>
							<xsl:value-of select="Comments" />
						</w:t>
					</w:r>
				</w:p>
			</xsl:if>
			<xsl:if test="(Notes)!=''">
				<w:p>
					<w:r>
						<w:t>Notes: </w:t>
					</w:r>
					<w:rPr>
						<w:b w:val="on" />
					</w:rPr>
					<w:r>
						<w:t>
							<xsl:value-of select="Notes" />
						</w:t>
					</w:r>
				</w:p>
			</xsl:if>

			<w:tbl>

				<w:tblPr>
					<w:tblStyle w:val="tblStyle4" />
					<w:tblW w:w="5000" w:type="pct" />
				</w:tblPr>

				<w:tr>
					<w:tc>
						<w:p>
							<w:r>
								<w:t>Parent Entity</w:t>
							</w:r>
						</w:p>
					</w:tc>
					<w:tc>
						<w:p>
							<w:r>
								<w:t>
									<xsl:value-of select="O1/FullName" />
								</w:t>
							</w:r>
						</w:p>
					</w:tc>
					<w:tc>
						<w:p>
							<w:r>
								<w:t>Parent Columns</w:t>
							</w:r>
						</w:p>
					</w:tc>
					<w:tc>
						<w:p>
							<w:r>
								<w:t>
									<xsl:choose>
										<xsl:when test="count(ForeignKeys/ForeignKey) = 1">
											<xsl:value-of select="ForeignKeys/ForeignKey/ParentAttribute/Name" />
										</xsl:when>
										<xsl:otherwise>
											<xsl:for-each select="ForeignKeys/ForeignKey">
												<xsl:value-of select="ParentAttribute/Name" />
												<xsl:if test="position() != last()">
													<xsl:value-of select="', '" />
												</xsl:if>
											</xsl:for-each>
										</xsl:otherwise>
									</xsl:choose>
								</w:t>
							</w:r>
						</w:p>
					</w:tc>
				</w:tr>

				<w:tr>
					<w:tc>
						<w:p>
							<w:r>
								<w:t>Child Enity</w:t>
							</w:r>
						</w:p>
					</w:tc>
					<w:tc>
						<w:p>
							<w:r>
								<w:t>
									<xsl:value-of select="O2/FullName" />
								</w:t>
							</w:r>
						</w:p>
					</w:tc>

					<w:tc>
						<w:p>
							<w:r>
								<w:t>Child Columns</w:t>
							</w:r>
						</w:p>
					</w:tc>
					<w:tc>
						<w:p>
							<w:r>
								<w:t>
									<xsl:choose>
										<xsl:when test="count(ForeignKeys/ForeignKey) = 1">
											<xsl:value-of select="ForeignKeys/ForeignKey/ChildAttribute/Name" />
										</xsl:when>
										<xsl:otherwise>
											<xsl:for-each select="ForeignKeys/ForeignKey">
												<xsl:value-of select="ChildAttribute/Name" />
												<xsl:if test="position() != last()">
													<xsl:value-of select="', '" />
												</xsl:if>
											</xsl:for-each>
										</xsl:otherwise>
									</xsl:choose>
								</w:t>
							</w:r>
						</w:p>
					</w:tc>
				</w:tr>

				<w:tr>
					<w:tc>
						<w:p>
							<w:r>
								<w:t>Mandatory Parent</w:t>
							</w:r>
						</w:p>
					</w:tc>
					<w:tc>
						<w:p>
							<w:r>
								<w:t>
									<xsl:call-template name="BooleanToText">
										<xsl:with-param name="PassedValue" select="MandatoryParent" />
									</xsl:call-template>
								</w:t>
							</w:r>
						</w:p>
					</w:tc>
					<w:tc>
						<w:p>
							<w:r>
								<w:t>Mandatory child</w:t>
							</w:r>
						</w:p>
					</w:tc>
					<w:tc>
						<w:p>
							<w:r>
								<w:t>
									<xsl:call-template name="BooleanToText">
										<xsl:with-param name="PassedValue" select="MandatoryChild" />
									</xsl:call-template>
								</w:t>
							</w:r>
						</w:p>
					</w:tc>
				</w:tr>

				<w:tr>
					<w:tc>
						<w:p>
							<w:r>
								<w:t>Identifying</w:t>
							</w:r>
						</w:p>
					</w:tc>
					<w:tc>
						<w:p>
							<w:r>
								<w:t>
									<xsl:call-template name="BooleanToText">
										<xsl:with-param name="PassedValue" select="Identifying" />
									</xsl:call-template>
								</w:t>
							</w:r>
						</w:p>
					</w:tc>
					<w:tc>
						<w:p>
							<w:r>
								<w:t>Cardinality</w:t>
							</w:r>
						</w:p>
					</w:tc>
					<w:tc>
						<w:p>
							<w:r>
								<w:t>
									<xsl:text>1:</xsl:text>
									<xsl:choose>
										<xsl:when test="contains(CardinalityChild, '-1')">
											<xsl:text>N</xsl:text>
										</xsl:when>
										<xsl:otherwise>
											<xsl:value-of select="CardinalityChild" />
										</xsl:otherwise>
									</xsl:choose>
								</w:t>
							</w:r>
						</w:p>
					</w:tc>
				</w:tr>

			</w:tbl>

			<w:p>
				<w:pPr>
					<w:pStyle w:val="Caption3" />
				</w:pPr>
				<w:r>
					<w:t>Referential Integrity</w:t>
				</w:r>
			</w:p>

			<w:tbl>

				<w:tblPr>
					<w:tblStyle w:val="tblStyle2" />
					<w:tblW w:w="5000" w:type="pct" />
					<w:tblLook w:val="000001E0" />
				</w:tblPr>

				<w:tr>
					<w:tc>
						<w:p>
							<w:r>
								<w:t></w:t>
							</w:r>
						</w:p>
					</w:tc>
					<w:tc>
						<w:p>
							<w:r>
								<w:t>Insert</w:t>
							</w:r>
						</w:p>
					</w:tc>
					<w:tc>
						<w:p>
							<w:r>
								<w:t>Update</w:t>
							</w:r>
						</w:p>
					</w:tc>
					<w:tc>
						<w:p>
							<w:r>
								<w:t>Delete</w:t>
							</w:r>
						</w:p>
					</w:tc>
				</w:tr>

				<w:tr>
					<w:tc>
						<w:p>
							<w:r>
								<w:t>Parent</w:t>
							</w:r>
						</w:p>
					</w:tc>
					<w:tc>
						<w:p>
							<w:r>
								<w:t></w:t>
							</w:r>
						</w:p>
					</w:tc>
					<w:tc>
						<w:p>
							<w:r>
								<w:t>
									<xsl:value-of select="RefIntegrityParentUpdate" />
								</w:t>
							</w:r>
						</w:p>
					</w:tc>
					<w:tc>
						<w:p>
							<w:r>
								<w:t>
									<xsl:value-of select="RefIntegrityParentDelete" />
								</w:t>
							</w:r>
						</w:p>
					</w:tc>
				</w:tr>
				<w:tr>
					<w:tc>
						<w:p>
							<w:r>
								<w:t>Child</w:t>
							</w:r>
						</w:p>
					</w:tc>
					<w:tc>
						<w:p>
							<w:r>
								<w:t>
									<xsl:value-of select="RefIntegrityChildInsert" />
								</w:t>
							</w:r>
						</w:p>
					</w:tc>
					<w:tc>
						<w:p>
							<w:r>
								<w:t>
									<xsl:value-of select="RefIntegrityChildUpdate" />
								</w:t>
							</w:r>
						</w:p>
					</w:tc>
					<w:tc>
						<w:p>
							<w:r>
								<w:t></w:t>
							</w:r>
						</w:p>
					</w:tc>
				</w:tr>

			</w:tbl>
		</xsl:for-each>
	</xsl:template>

	<!-- *********************************************************************************** -->
	<!-- Model Info -->
	<!-- *********************************************************************************** -->
	<xsl:template name="ModelInfo">

		<w:p>
			<w:pPr>
				<w:pStyle w:val="Caption1" />
			</w:pPr>
			<w:r>

				<w:t>Database model documentation</w:t>
			</w:r>
		</w:p>

		<w:tbl>

			<w:tblPr>
				<w:tblStyle w:val="tblStyle4" />
				<w:tblW w:w="5000" w:type="pct" />
			</w:tblPr>

			<w:tr>
				<w:tc>
					<w:p>
						<w:r>
							<w:t>Model name</w:t>
						</w:r>
					</w:p>
				</w:tc>
				<w:tc>
					<w:p>
						<w:r>
							<w:t>
								<xsl:value-of select="//Model/ModelTitle/ModelName" />
							</w:t>
						</w:r>
					</w:p>
				</w:tc>

				<w:tc>
					<w:p>
						<w:r>
							<w:t>Created</w:t>
						</w:r>
					</w:p>
				</w:tc>
				<w:tc>
					<w:p>
						<w:r>
							<w:t>
								<xsl:value-of
									select="format-number(number(substring(string(string(//Model/ModelTitle/CreatedDate)), 6, 2)), '00', 'format1')" />
								<xsl:text>/</xsl:text>
								<xsl:value-of
									select="format-number(number(substring(string(string(//Model/ModelTitle/CreatedDate)), 9, 2)), '00', 'format1')" />
								<xsl:text>/</xsl:text>
								<xsl:value-of
									select="format-number(number(substring(string(string(string(//Model/ModelTitle/CreatedDate))), 1, 4)), '0000', 'format1')" />
							</w:t>
						</w:r>
					</w:p>
				</w:tc>

			</w:tr>

			<w:tr>
				<w:tc>
					<w:p>
						<w:r>
							<w:t>Author</w:t>
						</w:r>
					</w:p>
				</w:tc>
				<w:tc>
					<w:p>
						<w:r>
							<w:t>
								<xsl:value-of select="//Model/ModelTitle/Author" />
							</w:t>
						</w:r>
					</w:p>
				</w:tc>
				<w:tc>
					<w:p>
						<w:r>
							<w:t>Company</w:t>
						</w:r>
					</w:p>
				</w:tc>
				<w:tc>
					<w:p>
						<w:r>
							<w:t>
								<xsl:value-of select="//Model/ModelTitle/Company" />
							</w:t>
						</w:r>
					</w:p>
				</w:tc>

			</w:tr>


		</w:tbl>
		<xsl:if test="(Model/ModelTitle/Description)!=''">
			<w:p>
				<w:r>
					<w:t>Description: </w:t>
				</w:r>
				<w:rPr>
					<w:b w:val="on" />
				</w:rPr>
				<w:r>
					<w:t>
						<xsl:value-of select="//Model/ModelTitle/Description" />
					</w:t>
				</w:r>
			</w:p>
		</xsl:if>
		<xsl:if test="(//Model/ModelTitle/Notes)!=''">
			<w:p>
				<w:r>
					<w:t>Notes: </w:t>
				</w:r>
				<w:rPr>
					<w:b w:val="on" />
				</w:rPr>
				<w:r>
					<w:t>
						<xsl:value-of select="//Model/ModelTitle/Notes" />
					</w:t>
				</w:r>
			</w:p>
		</xsl:if>

	</xsl:template>


	<!-- *********************************************************************************** -->
	<!-- To Do Report -->
	<!-- *********************************************************************************** -->
	<xsl:template name="ToDo">

		<w:p>
			<w:pPr>
				<w:pStyle w:val="Caption1" />
			</w:pPr>
			<w:r>

				<w:t>ToDo List</w:t>
			</w:r>
		</w:p>

		<xsl:choose>
			<xsl:when test="count(//Model/ToDoItems/ToDo) > 0">
				<w:tbl>

					<w:tblPr>
						<w:tblStyle w:val="tblStyle1" />
						<w:tblW w:w="5000" w:type="pct" />
						<w:tblLook w:val="000001E0" />
					</w:tblPr>

					<w:tr>
						<w:tc>
							<w:p>
								<w:r>
									<w:t>Name</w:t>
								</w:r>
							</w:p>
						</w:tc>
						<w:tc>
							<w:p>
								<w:r>
									<w:t>Text</w:t>
								</w:r>
							</w:p>
						</w:tc>

						<w:tc>
							<w:p>
								<w:r>
									<w:t>Category</w:t>
								</w:r>
							</w:p>
						</w:tc>
						<w:tc>
							<w:p>
								<w:r>
									<w:t>Priority</w:t>
								</w:r>
							</w:p>
						</w:tc>
						<w:tc>
							<w:p>
								<w:r>
									<w:t>Object</w:t>
								</w:r>
							</w:p>
						</w:tc>
						<w:tc>
							<w:p>
								<w:r>
									<w:t>Target Date</w:t>
								</w:r>
							</w:p>
						</w:tc>
						<w:tc>
							<w:p>
								<w:r>
									<w:t>Done</w:t>
								</w:r>
							</w:p>
						</w:tc>
					</w:tr>



					<xsl:for-each select="Model/ToDoItems/ToDo">
						<xsl:sort select="Done" data-type="text" order="ascending" />

						<w:tr>
							<w:tc>
								<w:p>
									<w:r>
										<w:t>
											<xsl:value-of select="Name" />
										</w:t>
									</w:r>
								</w:p>
							</w:tc>
							<w:tc>
								<w:p>
									<w:r>
										<w:t>
											<xsl:value-of select="Text" />
										</w:t>
									</w:r>
								</w:p>
							</w:tc>
							<w:tc>
								<w:p>
									<w:r>
										<w:t>
											<xsl:value-of select="Category" />
										</w:t>
									</w:r>
								</w:p>
							</w:tc>
							<w:tc>
								<w:p>
									<w:r>
										<w:t>
											<xsl:value-of select="Priority" />
										</w:t>
									</w:r>
								</w:p>
							</w:tc>
							<w:tc>
								<w:p>
									<w:r>
										<w:t>
											<xsl:for-each select="Object">											
												<xsl:value-of select="Name" />
												<xsl:text> (</xsl:text> 
												<xsl:value-of select="Type" />
												<xsl:text>)</xsl:text>
											</xsl:for-each>
										</w:t>
									</w:r>
								</w:p>
							</w:tc>
							<w:tc>
								<w:p>
									<w:r>
										<w:t>
											<xsl:value-of
												select="format-number(number(substring(string(string(TargetDate)), 9, 2)), '00', 'format1')" />
											<xsl:text>/</xsl:text>
											<xsl:value-of
												select="format-number(number(substring(string(string(TargetDate)), 6, 2)), '00', 'format1')" />
											<xsl:text>/</xsl:text>
											<xsl:value-of
												select="format-number(number(substring(string(string(string(TargetDate))), 1, 4)), '0000', 'format1')" />
										</w:t>
									</w:r>
								</w:p>
							</w:tc>
							<w:tc>
								<w:p>
									<w:r>
										<w:t>
											<xsl:choose>
												<xsl:when test="Done = 1">
													<xsl:text>Yes</xsl:text>
												</xsl:when>
												<xsl:otherwise>
													<xsl:text>No</xsl:text>
												</xsl:otherwise>
											</xsl:choose>
										</w:t>
									</w:r>
								</w:p>
							</w:tc>
						</w:tr>
					</xsl:for-each>
				</w:tbl>
			</xsl:when>
			<xsl:otherwise>
				<w:p>
					<w:r>
						<w:t>No ToDo items found.</w:t>
					</w:r>
				</w:p>
			</xsl:otherwise>
		</xsl:choose>
	</xsl:template>

</xsl:stylesheet>
